<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>

<html>
<head>
<script type="text/javascript">

var req;
var equip;

function setElementoClicado(equipClicado) {
	equip = equipClicado;
}

function criaObjetoXMLHttpRequest() {

	if ( req != null )
		return;
		
    if (window.XMLHttpRequest) {
        req = new XMLHttpRequest();
    } else if (window.ActiveXObject) {
        req = new ActiveXObject("Microsoft.XMLHTTP");
    }
}

function listarTiposDeBusca(profundidade) {
    var url = "listar?equip=" + equip + "&profundidade=" + profundidade;
    criaObjetoXMLHttpRequest();
    req.onreadystatechange = processRequestListarTiposDeBusca;
    req.open("GET", url, true); 
    req.send(null);
}

function buscar(tipoDeBusca,profundidade) {
    var url = "buscar?equip=" + equip + "&profundidade=" + profundidade + "&tipoDeBusca=" + tipoDeBusca;
    criaObjetoXMLHttpRequest();
    req.onreadystatechange = processRequestBuscar;
    req.open("GET", url, true); 
    req.send(null);
}

function processRequestListarTiposDeBusca() {

    if (req.readyState == 4) {
        if (req.status == 200) {

			var message = req.responseXML.getElementsByTagName("message")[0];

			profundidade = message.getElementsByTagName("profundidade")[0].childNodes[0].nodeValue;            
			profundidade = parseInt(profundidade) + 1;
			
            var selectText = "<select name=\"valor" + profundidade + "\">";
            for (var cont=0; cont < message.getElementsByTagName("tipoDeBusca").length; cont++) {
            	var tipoDeBusca = message.getElementsByTagName("tipoDeBusca")[cont].childNodes[0].nodeValue;
            	selectText += "<option onclick=\"setElementoClicado('" + equip + "');buscar('" + tipoDeBusca + "'," + profundidade + ");\">" + tipoDeBusca + "</option>";
            }
            selectText += "</select>";

            disableSubmitBtn();

            setMessageUsingDOM(selectText, profundidade);
        }
    }
}

function processRequestBuscar() {

    if (req.readyState == 4) {
        if (req.status == 200) {

			var message = req.responseXML.getElementsByTagName("message")[0];
			profundidade = message.getElementsByTagName("profundidade")[0].childNodes[0].nodeValue;            
            var tipoDeBusca = message.getElementsByTagName("tipoDeBusca")[0].childNodes[0].nodeValue;

            var selectText = "<select name=\"valor" + profundidade + "\" id=\"valor" + profundidade + "\">";
            for (var cont=0; cont < message.getElementsByTagName("resultado").length; cont++) {
	            var resultado = message.getElementsByTagName("resultado")[cont].childNodes[0].nodeValue;
	            if ( tipoDeBusca == 'Equipamentos Relacionados' ) {
		            disableSubmitBtn();
	            	selectText += "<option onclick=\"setElementoClicado('" + resultado + "');listarTiposDeBusca(" + profundidade + ")\">" + resultado + "</option>";
	            } else {
		            enableSubmitBtn();
		            selectText += "<option>" + resultado + "</option>";
	            }
            }
            selectText += "</select>";

            if ( tipoDeBusca == 'Equipamentos Relacionados' ) {
	            selectText += ".";
	        }
            
            setMessageUsingDOM(selectText, profundidade);
        }
    }
}

function setMessageUsingDOM(message, profundidade) {
	var userMessageElement = document.getElementById("cell" + profundidade);
	userMessageElement.innerHTML = message;
	for ( var cont = profundidade + 1; document.getElementById("cell" + cont); cont++) {
	     document.getElementById("cell" + cont).innerHTML = "";
	}
}

function storeCaret (textEl) {
	if (textEl.createTextRange) 
		textEl.caretPos = document.selection.createRange().duplicate();
}

function insertAtCaret (textEl) {

	text = "";
	for ( var cont = 1; document.getElementById("valor" + cont); cont ++ ) {
		if ( cont != 1 ) text += ".";
		text += document.getElementById("valor" + cont).value;
	}

	if (textEl.createTextRange && textEl.caretPos) {
		var caretPos = textEl.caretPos;
		caretPos.text = caretPos.text.charAt(caretPos.text.length - 1) == ' ' ? text + ' ' : text;
	}
	else textEl.value  += text;
}


function disableSubmitBtn() {
    var submitBtn = document.getElementById("inserir");
    submitBtn.disabled = true;
}

function enableSubmitBtn() {
    var submitBtn = document.getElementById("inserir");
    submitBtn.disabled = false;
}

</script>
</head>

<body onload="setElementoClicado('linha');listarTiposDeBusca(0);disableSubmitBtn();">
	<table align="center">
	<tr>
		<td>
			<form name="aForm">
				<textarea name="aTextArea" rows="8" cols="100" onselect="storeCaret(this);" onclick="storeCaret(this);" onkeyup="storeCaret(this);"></textarea>
				<br>
			    <table border="0" cellpadding="2">
			    	<tr>
			    		<td><div id="cell1"></div></td>
			    		<td><div id="cell2"></div></td>
			    		<td><div id="cell3"></div></td>
			    		<td><div id="cell4"></div></td>
			    		<td><div id="cell5"></div></td>
			    	</tr>
			    </table>
				<input TYPE="button" id="inserir" VALUE="Inserir" ONCLICK="insertAtCaret(this.form.aTextArea);">
				<input TYPE="button" id="reset" VALUE="Reset" ONCLICK="setElementoClicado('linha');listarTiposDeBusca(0);">
			</form>
		</td></tr>
	</table>
</body>
</html>
