import java.io.IOException;
import java.util.HashMap;

import javax.servlet.ServletConfig;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class ControladorServlet extends HttpServlet {

    private ServletContext context;
 
    public void init(ServletConfig config) throws ServletException {
        this.context = config.getServletContext();
    }

    public void doGet(HttpServletRequest request, HttpServletResponse  response)
        throws IOException, ServletException {

        if (request.getRequestURI().endsWith("/listar")) {
        	processaListar(request, response);
        }
        else if (request.getRequestURI().endsWith("/buscar")) {
        	processaBuscar(request, response);
        }
        
    }

	private void processaBuscar(HttpServletRequest request, HttpServletResponse response) throws IOException {

        String equip = request.getParameter("equip");
        String profundidade = request.getParameter("profundidade");
        String tipoDeBusca = request.getParameter("tipoDeBusca");
        
        String equipXml = "<equip>" + equip + "</equip>";
        String profundidadeXml = "<profundidade>" + profundidade + "</profundidade>";
        String tipoDeBuscaXml = "<tipoDeBusca>" + tipoDeBusca + "</tipoDeBusca>";

        if ( "linha".equals(equip) ) {
            response.setContentType("text/xml");
            response.setHeader("Cache-Control", "no-cache");
	        if ( "Eventos".equals(tipoDeBusca) ) {
	            response.getWriter().write("<message>" + profundidadeXml + tipoDeBuscaXml + equipXml + "<resultado>ATPR-DE</resultado><resultado>SCON-DE</resultado></message>"); 
	        } else if ( "Macros".equals(tipoDeBusca) ) {
	            response.getWriter().write("<message>" + profundidadeXml + tipoDeBuscaXml + equipXml + "<resultado>atuouProtecao()</resultado><resultado>atuouSobretensao()</resultado></message>"); 
	        } else if ( "Equipamentos Relacionados".equals(tipoDeBusca) ) {
	            response.getWriter().write("<message>" + profundidadeXml + tipoDeBuscaXml + equipXml + "<resultado>r</resultado><resultado>dj</resultado></message>"); 
	        }
        } else if ( "dj".equals(equip) ) {
            response.setContentType("text/xml");
            response.setHeader("Cache-Control", "no-cache");
	        if ( "Eventos".equals(tipoDeBusca) ) {
	            response.getWriter().write("<message>" + profundidadeXml + tipoDeBuscaXml + equipXml + "<resultado>ABER</resultado><resultado>FECH</resultado></message>"); 
	        } 
        } else if ( "r".equals(equip) ) {
            response.setContentType("text/xml");
            response.setHeader("Cache-Control", "no-cache");
	        if ( "Eventos".equals(tipoDeBusca) ) {
	            response.getWriter().write("<message>" + profundidadeXml + tipoDeBuscaXml + equipXml + "<resultado>ATRB</resultado></message>"); 
	        } else if ( "Equipamentos Relacionados".equals(tipoDeBusca) ) {
	            response.getWriter().write("<message>" + profundidadeXml + tipoDeBuscaXml + equipXml + "<resultado>dj</resultado></message>"); 
	        }
        }
	}

	private void processaListar(HttpServletRequest request, HttpServletResponse response) throws IOException {
        String equip = request.getParameter("equip");
        String profundidade = request.getParameter("profundidade");

        String equipXml = "<equip>" + equip + "</equip>";
        String profundidadeXml = "<profundidade>" + profundidade + "</profundidade>";
        
        if ( "linha".equals(equip) ) {
            response.setContentType("text/xml");
            response.setHeader("Cache-Control", "no-cache");
            response.getWriter().write("<message>" + profundidadeXml + equipXml + "<tipoDeBusca>Eventos</tipoDeBusca><tipoDeBusca>Macros</tipoDeBusca><tipoDeBusca>Equipamentos Relacionados</tipoDeBusca></message>"); 
        } else if ( "dj".equals(equip) ) {
            response.setContentType("text/xml");
            response.setHeader("Cache-Control", "no-cache");
            response.getWriter().write("<message>" + profundidadeXml + equipXml + "<tipoDeBusca>Eventos</tipoDeBusca></message>"); 
        } else if ( "r".equals(equip) ) {
            response.setContentType("text/xml");
            response.setHeader("Cache-Control", "no-cache");
            response.getWriter().write("<message>" + profundidadeXml + equipXml + "<tipoDeBusca>Eventos</tipoDeBusca><tipoDeBusca>Equipamentos Relacionados</tipoDeBusca></message>"); 
        }
	}
}
